<html>
<head>
<title>OgreShaderMaterialSerializerListener.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_f1fa7196649e3987904dbdb4948bc856.html">Components</a>      </li>
      <li class="navelem"><a class="el" href="dir_1ff0a99c786b1c34b8d04ba7e7285590.html">RTShaderSystem</a>      </li>
      <li class="navelem"><a class="el" href="dir_167378df2bdccc9b313fc91c17987f1d.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreShaderMaterialSerializerListener.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreShaderMaterialSerializerListener_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00009"></a>00009 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00010"></a>00010 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00011"></a>00011 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00012"></a>00012 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00013"></a>00013 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00016"></a>00016 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00017"></a>00017 <span class="comment"></span>
<a name="l00018"></a>00018 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00019"></a>00019 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00020"></a>00020 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00021"></a>00021 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00022"></a>00022 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00023"></a>00023 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00024"></a>00024 <span class="comment">THE SOFTWARE.</span>
<a name="l00025"></a>00025 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00026"></a>00026 <span class="comment">*/</span>
<a name="l00027"></a>00027 <span class="preprocessor">#ifndef _ShaderMaterialSerializerListener_</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span><span class="preprocessor">#define _ShaderMaterialSerializerListener_</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderPrerequisites_8h.html">OgreShaderPrerequisites.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreMaterialSerializer_8h.html">OgreMaterialSerializer.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderGenerator_8h.html">OgreShaderGenerator.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>Ogre {
<a name="l00035"></a>00035 <span class="keyword">namespace </span>RTShader {
<a name="l00036"></a>00036 
<a name="l00047"></a><a class="code" href="classOgre_1_1RTShader_1_1SGMaterialSerializerListener.html">00047</a> <span class="keyword">class </span><a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> <a class="code" href="classOgre_1_1RTShader_1_1SGMaterialSerializerListener.html" title="This class responsible for translating core features of the RT Shader System for Ogre material script...">SGMaterialSerializerListener</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1MaterialSerializer.html" title="Class for serializing Materials to / from a .material script.">MaterialSerializer</a>::Listener, <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">RTShaderSystemAlloc</a>
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 <span class="comment">// Interface.</span>
<a name="l00051"></a>00051 <span class="keyword">public</span>:
<a name="l00052"></a>00052 
<a name="l00056"></a>00056     <span class="keyword">virtual</span> <span class="keywordtype">void</span> materialEventRaised(<a class="code" href="classOgre_1_1MaterialSerializer.html" title="Class for serializing Materials to / from a .material script.">MaterialSerializer</a>* ser, 
<a name="l00057"></a>00057         <a class="code" href="classOgre_1_1MaterialSerializer.html#a237c1a8b1e58e28c793e1c3febc86d4b">MaterialSerializer::SerializeEvent</a> event, <span class="keywordtype">bool</span>&amp; skip, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Material.html" title="Class encapsulates rendering properties of an object.">Material</a>* mat);
<a name="l00058"></a>00058 
<a name="l00062"></a>00062     <span class="keyword">virtual</span> <span class="keywordtype">void</span> techniqueEventRaised(<a class="code" href="classOgre_1_1MaterialSerializer.html" title="Class for serializing Materials to / from a .material script.">MaterialSerializer</a>* ser, 
<a name="l00063"></a>00063         <a class="code" href="classOgre_1_1MaterialSerializer.html#a237c1a8b1e58e28c793e1c3febc86d4b">MaterialSerializer::SerializeEvent</a> event, <span class="keywordtype">bool</span>&amp; skip, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* tech);
<a name="l00064"></a>00064 
<a name="l00068"></a>00068     <span class="keyword">virtual</span> <span class="keywordtype">void</span> passEventRaised(<a class="code" href="classOgre_1_1MaterialSerializer.html" title="Class for serializing Materials to / from a .material script.">MaterialSerializer</a>* ser, 
<a name="l00069"></a>00069         <a class="code" href="classOgre_1_1MaterialSerializer.html#a237c1a8b1e58e28c793e1c3febc86d4b">MaterialSerializer::SerializeEvent</a> event, <span class="keywordtype">bool</span>&amp; skip, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* tech);
<a name="l00070"></a>00070 
<a name="l00074"></a>00074     <span class="keyword">virtual</span> <span class="keywordtype">void</span> textureUnitStateEventRaised(<a class="code" href="classOgre_1_1MaterialSerializer.html" title="Class for serializing Materials to / from a .material script.">MaterialSerializer</a>* ser, 
<a name="l00075"></a>00075         <a class="code" href="classOgre_1_1MaterialSerializer.html#a237c1a8b1e58e28c793e1c3febc86d4b">MaterialSerializer::SerializeEvent</a> event, <span class="keywordtype">bool</span>&amp; skip, <span class="keyword">const</span> <a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique, of a Material.">TextureUnitState</a>* textureUnit);
<a name="l00076"></a>00076   
<a name="l00077"></a>00077 <span class="comment">// Types.</span>
<a name="l00078"></a>00078 <span class="keyword">protected</span>:
<a name="l00079"></a><a class="code" href="group__RTShader.html#ga31c3b1b2f0c870611f7acb6a54223483">00079</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;ShaderGenerator::SGPass*&gt;::type</a>  <a class="code" href="group__RTShader.html#ga31c3b1b2f0c870611f7acb6a54223483">SGPassList</a>;
<a name="l00080"></a><a class="code" href="group__RTShader.html#ga6a93f168082a6e969a5fb34805cc1133">00080</a>     <span class="keyword">typedef</span> SGPassList::iterator                    <a class="code" href="group__RTShader.html#ga6a93f168082a6e969a5fb34805cc1133">SGPassListIterator</a>;
<a name="l00081"></a><a class="code" href="group__RTShader.html#gade464788781f7916b5c80ebab37ca19c">00081</a>     <span class="keyword">typedef</span> SGPassList::const_iterator              <a class="code" href="group__RTShader.html#gade464788781f7916b5c80ebab37ca19c">SGPassListConstIterator</a>;
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 <span class="comment">// Protected methods.</span>
<a name="l00084"></a>00084 <span class="keyword">protected</span>:
<a name="l00086"></a>00086     <a class="code" href="classOgre_1_1RTShader_1_1SGMaterialSerializerListener.html" title="This class responsible for translating core features of the RT Shader System for Ogre material script...">SGMaterialSerializerListener</a>();
<a name="l00087"></a>00087     ~<a class="code" href="classOgre_1_1RTShader_1_1SGMaterialSerializerListener.html" title="This class responsible for translating core features of the RT Shader System for Ogre material script...">SGMaterialSerializerListener</a>();
<a name="l00088"></a>00088 
<a name="l00090"></a>00090     <span class="keywordtype">void</span>                        createSGPassList        (<a class="code" href="classOgre_1_1Material.html" title="Class encapsulates rendering properties of an object.">Material</a>* mat, <a class="code" href="group__RTShader.html#ga31c3b1b2f0c870611f7acb6a54223483">SGPassList</a>&amp; passList);
<a name="l00091"></a>00091 
<a name="l00093"></a>00093     <a class="code" href="classOgre_1_1RTShader_1_1ShaderGenerator_1_1SGPass.html" title="Shader generator pass wrapper class.">ShaderGenerator::SGPass</a>*    getShaderGeneratedPass  (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* srcPass);
<a name="l00094"></a>00094     
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 <span class="comment">// Attributes.</span>
<a name="l00097"></a>00097 <span class="keyword">protected</span>:  
<a name="l00098"></a><a class="code" href="group__RTShader.html#ga7deb2ec07837651de38e79a33a2bbc1c">00098</a>     <a class="code" href="classOgre_1_1Material.html" title="Class encapsulates rendering properties of an object.">Material</a>*       <a class="code" href="group__RTShader.html#ga7deb2ec07837651de38e79a33a2bbc1c">mSourceMaterial</a>;        <span class="comment">// The current source material that is being written.</span>
<a name="l00099"></a><a class="code" href="group__RTShader.html#ga0ee048c5fb3aa3e3b8daa4bbd64fffa3">00099</a>     <a class="code" href="group__RTShader.html#ga31c3b1b2f0c870611f7acb6a54223483">SGPassList</a>      <a class="code" href="group__RTShader.html#ga0ee048c5fb3aa3e3b8daa4bbd64fffa3">mSGPassList</a>;            <span class="comment">// List of SGPass instances composing this material.</span>
<a name="l00100"></a>00100     
<a name="l00101"></a>00101     
<a name="l00102"></a>00102 <span class="keyword">private</span>:
<a name="l00103"></a><a class="code" href="group__RTShader.html#gadcb2ff432738c3d0e602910347d3785a">00103</a>     <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1RTShader_1_1ShaderGenerator.html" title="Shader generator system main interface.">ShaderGenerator</a>;
<a name="l00104"></a>00104 };
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 }
<a name="l00107"></a>00107 }
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
